$!-
$!   CLEANUP-MAIL.COM V1.1, 1994-06-08
$!
$!   Copyright (c) 1993, Brian McKeever (McKeever@CSTP.UMKC.EDU)
$!
$!   This program may be freely redistributed at no charge provided that this
$!   notice is left intact.  Modified copies must preserve this notice.  It is
$!   also requested that any useful changes you make to it be sent to the
$!   author.
$!-
$!   This command procedure go throughs an entire disk (P1) and compresses
$!   every MAIL.MAI file on 'P1.  Since I can't get users to do it
$!   themselves.  The first time I ran it I went from 25MBytes worth of mail
$!   files to 12MBytes.  Definately worth writing.
$!
$!   I m p o r t a n t :
$!
$!	You will PROBABLY have to edit this file for your site specific
$!	requirements.  Search for `SCRATCH' and `mail_owner'.  Novice
$!	system managers are warned to be very careful.  Using this procedure
$!	can do no harm per se, but executing the command procedure it
$!	creates can be tricky if any problems arise during its execution.
$!	Make sure you understand completely what it will be doing _before_
$!	you execute the compress procedure.
$!
$!   Instead of actually doing the compression, it writes a command procedure
$!   you can activate at the top-level of the disk that actually does the
$!   compression.  You can also compress one mail file at a time by passing
$!   the command procedure that it writes a parameter which is the label you
$!   want it to branch to.  You might want to submit the job batch as the
$!   compression can take a while.
$!
$!   W a r n i n g :
$!
$!	It is suggested that you execute the mail compression procedure that
$!	is written from an account that has the privileges BYPASS and EXQUOTA
$!	turned on!
$!
$!   P2 is the minimum size a mail file has to be before it is compressed.
$!   Files smaller than 'P2 will be ignored.
$!
$!   If P3 is "SUM" then it just goes through 'P1 and displays the size of
$!   each mail file on the disk.  No command procedure is written.  P2 is
$!   still checked.
$!
$!   Any file that the user has in their WASTEBASKET folder are saved to
$!   the directory pointed to by SCRATCH and the user is sent a mail message
$!   indicating that some files were preserved for them there.  At our site
$!   our SCRATCH device is cleaned up every night.  Any file 7 days old there
$!   or older is automatically deleted.  About 5% of our users were QUITing
$!   instead of EXITing mail.
$!
$!   W a r n i n g :
$!
$!	If a user has changed their WASTEBASKET folder, any mail messages they
$!	have in their non-standard wastebasket folder will be deleted without
$!	them being saved to a file!  It was not practical to determine the 
$!	wastebasket folder for each user.  Not a single one of our 250+ users
$!	had changed their wastebasket folder.
$!
$!   N o t e :
$!
$!	The username to send the message that a users WASTEBASKET folder
$!	has been emptied is determined by getting the owner of the MAIL.MAI
$!	file and then stripping off the brackets around it.  Our RIGHTS
$!	identifiers for usernames are in "[<username>]" format to this
$!	works quite well.  If you have some other RIGHTS identifier format,
$!	you will have to edit this procedure to change how it determines
$!	the `mail_owner'.  For example, if your identifiers are in the format
$!	"[<group>,<username>]" then this will give you the owners username:
$!
$!		mail_owner = f$element(1, ",", -
$!			     f$file_attributes(file_spec, "UIC")) - "]"
$!
$!	Your milage may vary.
$!
$!   P o s s i b l e   P r o b l e m s :
$!
$!	Probably lots of them.  The only one that comes to mind is if someone
$!	is compressing or has otherwise locked their MAIL.MAI file when the
$!	compress procedure runs.  This results in the temporary compress file
$!	hanging around.  The compress procedure checks for these files and
$!	cleans thems up (DELETEs them) if it finds any so the user should be
$!	no worse off.  The lock just keeps their mail file from being com-
$!	pressed.  I had it happen and it doesn't appear to hurt anything.  I
$!	just noted the label name and then called the compress procedure again
$!	after the rest of the files were converted with the label.
$!-
$!
$!   M o d i f i c a t i o n s :
$!
$!						       Brian, 1194-06-08.03
$!
$!   Added SET ACL/DELETE on the trashed mail file.
$!
$!						       Brian, 1194-06-08.02
$!
$!   Block size skipping didn't work.  What a brain doner I am.  It
$!   created endless loop procedures when you put in a block limit.
$!
$!						       Brian, 1194-06-08.01
$!
$!   It didn't work if you didn't include a device name.
$!   Cosmetic changes to the mail messages it sends out.
$!
$!						       Brian, 1993-06-22.01
$!
$!   Added program description comments and copyright notice so I could
$!   put it out for anonymous FTP.
$!
$!-
$!   P1 is the disk name.  If you don't give a P1 it uses the disk you
$!   are currently sitting on.
$!-
$    if p1 .eqs. ""
$	then default	= f$environment("DEFAULT")
$	else default	= p1
$    endif
$
$    device	= f$getdvi(default, "DEVNAM") - "_" - ":"
$    com_spec	= device + ":[000000]MAIL-CLEANUP.COM"
$    mask	= device + ":[000000...]MAIL.MAI"
$
$!-  Exit handler
$    on control_y then goto control_y_exit
$
$!-  The usual...
$    __		= "WRITE SYS$OUTPUT"
$    _w		= "WRITE COM_SPEC"
$    true	= 1 .and. 1
$    false	= 1 .and. 0
$
$    tot_alq	= 0	!  Total blocks found
$    file_cnt	= 0	!  Number of mail files found
$    ignore_cnt = 0	!  Number of files ignored
$
$!-  P2 is the minimum block size.  Files smaller than 'P2 are ignored.
$    if p2 .eqs ""
$	then min_block = 0
$	else min_block = f$integer(p2)
$    endif
$
$!-
$!   P3 is ignored if it isn't SUM.  If it is, then no command proc is
$!   written.  The file sizes and counts are all that are reported.
$!-
$    if p3 .eqs. "SUM"
$	then sum = true
$	else sum = false
$    endif
$
$!-  Informational messages
$    __ ""
$    __ "      Using Device:  ", device
$    __ "Minimum Block Size:  ", min_block
$    if .not. sum
$	then __ " Command Procedure:  ", com_spec
$    endif
$    __ ""
$
$!-
$    if sum then goto 005$		! Don't write if we are SUMming
$    create/fdl=sys$input 'com_spec
$    open/append com_spec 'com_spec
$    _w "$!-"
$    _w "$    CM_VERIFY = 'F$VERIFY(1)"
$    _w "$    SET NOON"
$    _w "$    SET OUTPUT=00:00:05"
$    _w "$"
$    _w "$!-"
$    _w "$    OLD_ALQ   = 0"
$    _w "$    NEW_ALQ   = 0"
$    _w "$    SUBPID    = F$EXTRACT(4, 4, F$GETJPI("""", ""PID""))"
$    _w "$    TEMP_REST = ""MAIL_"" + SUBPID + ""_COMPRESS.TMP"""
$    _w "$"
$    _w "$    IF P1 .NES. """" THEN GOTO 'P1"
$    _w "$"
$
$ 005$:
$
$ compress_loop:
$    file_spec	= f$search(mask, 777)
$    if file_spec .eqs. "" then goto compress_loop_end
$
$    alq	= f$file_attributes(file_spec, "ALQ")
$
$    ignore	= false
$    if (alq .gt. min_block)
$	then __ f$fao(" !9UL  !AS", alq, file_spec)
$	else ignore_cnt = ignore_cnt + 1
$	     ignore     = true
$    endif
$
$    if ignore then goto 010$
$    file_cnt	= file_cnt + 1
$    tot_alq	= tot_alq + alq
$
$ 007$:
$    if sum then goto 010$
$
$    t_folder = "WASTEBASKET"
$
$    old_spec	= f$element(0, ";", f$parse(".OLD", file_spec,,))
$    mail_home	= f$parse(file_spec,,,"DEVICE") + -
		  f$parse(file_spec,,,"DIRECTORY")
$    mail_owner = f$file_attributes(file_spec, "UIC") - "[" - "]"
$    if (mail_owner - ",") .nes. mail_owner
$	then mail_owner = "SYSTEM"
$    endif
$
$    trash_file	= "SCRATCH:TRASHED-MAIL-" + mail_owner + ".TXT"
$
$    _w "$!-"
$    _w "$"
$    _w "$ CLEANUP_MAIL_", file_cnt, ":"
$    _w "$    OLD_ALQ    = OLD_ALQ + F$FILE_ATT(""", file_spec, """, ""ALQ"")"
$    _w "$    TRASH_FILE = ""SCRATCH:TRASHED-MAIL-", mail_owner, ".TXT"""
$    _w "$    IF F$SEARCH(TRASH_FILE) .NES. """" THEN -"
$    _w "	RENAME/LOG/NOCONF 'TRASH_FILE *.OLD"
$    _w "$"
$    _w "$!-  Empty out the mail file"
$    _w	"$    MAIL"
$    _w "SET FILE ", file_spec
$    _w "SEL ", t_folder
$    _w "EXTRACT/ALL ", trash_file
$    _w "PURGE"
$    _w "COMPRESS"
$    _w "$"
$    _w "$!-  Get rid of the old mail files"
$    _w "$    IF F$SEARCH(""", old_spec, """) .NES. """" THEN -"
$    _w "	DELETE/LOG/NOCONF ", old_spec, ";*"
$    _w "$"
$    _w "$!-  Did the compress fail?"
$    _w "$    TEMP_SPEC = """, mail_home, """ + TEMP_REST"
$    _w "$    IF F$SEARCH(TEMP_SPEC) .NES. """" THEN -"
$    _w "	DELETE/LOG/NOCONF 'TEMP_SPEC;*"
$    _w "$"
$    _w "$!-  Size of the new mail file"
$    _w "$    NEW_ALQ = NEW_ALQ + F$FILE_ATT(""", file_spec, """, ""ALQ"")"
$    _w "$"
$    _w "$!-  Any trashed messages?"
$    _w "$    IF F$SEARCH(TRASH_FILE) .EQS. """" THEN GOTO END_", file_cnt
$    _w "$    SET FILE/PROT=(G,W)/OWNER=", mail_owner, " 'TRASH_FILE"
$    _w "$    SET ACL/DELETE 'TRASH_FILE"
$    _w "$    MAIL_OWNER = """, mail_owner, """"
$    _w "$    GOSUB MAIL_IT
$    _w "$"
$    _w "$ END_", file_cnt, ":"
$    _w "$    IF P1 .NES. """" THEN GOTO WRITE_STATS"
$    _w "$"
$
$ 010$:
$    goto compress_loop
$
$ control_y_exit:
$ compress_loop_end:
$    if sum then goto 015$
$    _w "$ WRITE_STATS:"
$    _w "$    WRITE SYS$OUTPUT ""Old ALQ:  "", OLD_ALQ"
$    _w "$    WRITE SYS$OUTPUT ""New ALQ:  "", NEW_ALQ"
$    _w "$    GOTO FINISH"
$    _w "$"
$    _w "$ MAIL_IT:"
$    _w "$    MAIL/NOSELF SYS$INPUT 'MAIL_OWNER ", -
	"/SUBJECT=""Deleted mail messages in '", "'TRASH_FILE'."""
$    _w "Your deleted mail messages have been purged from your mail file.  The"
$    _w "messages that were in your WASTEBASKET mail folder can be found in"
$    _w "the file mentioned in the subject of this message.  The file will be"
$    _w "deleted automatically in seven days if you do not retrieve it before"
$    _w "then."
$    _w ""
$    _w "Messages accumulate in your WASTEBASKET folder when you use QUIT"
$    _w "instead of EXIT (or CTRL-Z) to leave VMS Mail.  Feel free to reply"
$    _w "to this message if you have any questions."
$    _w ""
$    _w "-=Automated System Message"
$    _w "$    RETURN"
$    _w "$"
$    _w "$ FINISH:"
$    _w "$    CM_VERIFY = F$VERIFY(CM_VERIFY)"
$    close com_spec
$
$ 015$:
$    __ f$fao(" ---------!/ !9UL  (!UL file!%S, !UL ignored)", -
	      tot_alq, file_cnt, ignore_cnt)
$
$ finish:
$    exit
