$    ver  = 'f$verify(0)
$!-
$!  This procedure creates a detached DECterm window that you can log into
$!  as any user you want on the current node.  It sets the window and icon
$!  attributes so the the window is created with a descriptive title.
$!
$!  Parameters
$!	P1 - Optional name for window title AFTER the nodename
$!	P2 - Optional parameters to the CREATE command
$!
$!  Syntax:
$!      @WINDOW
$!		Results in a window called "DECterm <node>".
$!      @WINDOW "Foobar"
$!		Results in a window called "<node> Foobar".
$!	@WINDOW "Foobar" /NOBROAD
$!		Results in a window called "<node> Foobar" that is created
$!		/NOBROAD
$!
$!  Programmer:
$!	Brian McKeever (MCKEEVER@CSTP.UMKC.EDU), 8-7-91
$!-
$
$!-  Executing nodename
$    node = f$edit(f$getsyi("NODENAME"), "COLLAPSE")
$
$!-  Default window title and icon name
$    if p1 .eqs. ""
$	then win_attr = "DECterm ''node'"
$	else win_attr = "''node' ''p1'"
$    endif
$
$!-  Create the window
$    create/term/detach/nologged	-
	/window=(title="''win_attr'", icon="''win_attr'")'p2
$
$    create_status = $status	! Save the status
$    ver = f$verify(ver)	! Flip verify flag
$    exit 'create_status	! Exit with saved status
